commit d507bd269278537fab0a68a7e8d8f4ed81e85ada
Author: Vaclav Honzik <vaclavhonzik98@gmail.com>
Date:   Tue Mar 8 20:20:24 2022 +0100

    Java backend API init re #9106

diff --git a/backend/HELP.md b/backend/HELP.md
index cecc7ac..2e1bba6 100644
--- a/backend/HELP.md
+++ b/backend/HELP.md
@@ -1,17 +1,22 @@
+# Read Me First
+The following was discovered as part of building this project:
+
+* The original package name 'cz.zcu.kiv.backend-api' is invalid and this project uses 'cz.zcu.kiv.backendapi' instead.
+
 # Getting Started
 
 ### Reference Documentation
-
 For further reference, please consider the following sections:
 
 * [Official Apache Maven documentation](https://maven.apache.org/guides/index.html)
 * [Spring Boot Maven Plugin Reference Guide](https://docs.spring.io/spring-boot/docs/2.6.4/maven-plugin/reference/html/)
 * [Create an OCI image](https://docs.spring.io/spring-boot/docs/2.6.4/maven-plugin/reference/html/#build-image)
-* [Spring Data JPA](https://docs.spring.io/spring-boot/docs/2.6.4/reference/htmlsingle/#boot-features-jpa-and-spring-data)
+* [Spring Web](https://docs.spring.io/spring-boot/docs/2.6.4/reference/htmlsingle/#boot-features-developing-web-applications)
 
 ### Guides
-
 The following guides illustrate how to use some features concretely:
 
-* [Accessing Data with JPA](https://spring.io/guides/gs/accessing-data-jpa/)
+* [Building a RESTful Web Service](https://spring.io/guides/gs/rest-service/)
+* [Serving Web Content with Spring MVC](https://spring.io/guides/gs/serving-web-content/)
+* [Building REST services with Spring](https://spring.io/guides/tutorials/bookmarks/)
 
diff --git a/backend/pom.xml b/backend/pom.xml
index 1320202..09008fa 100644
--- a/backend/pom.xml
+++ b/backend/pom.xml
@@ -1,18 +1,18 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<project xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns="http://maven.apache.org/POM/4.0.0"
+<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
          xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 https://maven.apache.org/xsd/maven-4.0.0.xsd">
     <modelVersion>4.0.0</modelVersion>
     <parent>
         <groupId>org.springframework.boot</groupId>
         <artifactId>spring-boot-starter-parent</artifactId>
         <version>2.6.4</version>
-        <relativePath/> <!-- lookup parent from repository -->
+        <relativePath/>
     </parent>
     <groupId>cz.zcu.kiv</groupId>
-    <artifactId>backend</artifactId>
+    <artifactId>backend-api</artifactId>
     <version>0.0.1-SNAPSHOT</version>
-    <name>backend</name>
-    <description>Java API Backend</description>
+    <name>backend-api</name>
+    <description>Backend API for Neo-assyrian web application</description>
     <properties>
         <java.version>17</java.version>
     </properties>
@@ -21,25 +21,16 @@
             <groupId>org.springframework.boot</groupId>
             <artifactId>spring-boot-starter-web</artifactId>
         </dependency>
+
         <dependency>
             <groupId>org.projectlombok</groupId>
             <artifactId>lombok</artifactId>
             <optional>true</optional>
         </dependency>
         <dependency>
-            <groupId>org.apache.logging.log4j</groupId>
-            <artifactId>log4j-api</artifactId>
-            <version>2.17.2</version>
-        </dependency>
-        <dependency>
-            <groupId>org.apache.logging.log4j</groupId>
-            <artifactId>log4j-core</artifactId>
-            <version>2.17.2</version>
-        </dependency>
-        <dependency>
-            <groupId>org.springframework</groupId>
-            <artifactId>spring-webmvc</artifactId>
-            <version>5.0.6.RELEASE</version>
+            <groupId>org.springframework.boot</groupId>
+            <artifactId>spring-boot-starter-test</artifactId>
+            <scope>test</scope>
         </dependency>
     </dependencies>
 
diff --git a/backend/src/main/java/cz/zcu/kiv/backend/BackendApplication.java b/backend/src/main/java/cz/zcu/kiv/backend/BackendApplication.java
deleted file mode 100644
index 24a3262..0000000
--- a/backend/src/main/java/cz/zcu/kiv/backend/BackendApplication.java
+++ /dev/null
@@ -1,21 +0,0 @@
-package cz.zcu.kiv.backend;
-//
-
-import org.slf4j.Logger;
-import org.slf4j.LoggerFactory;
-import org.springframework.boot.SpringApplication;
-import org.springframework.boot.autoconfigure.SpringBootApplication;
-
-@SpringBootApplication
-public class BackendApplication {
-
-    public static final Logger LOGGER = LoggerFactory.getLogger(BackendApplication.class);
-
-    public static void main(String[] args) {
-        SpringApplication.run(BackendApplication.class, args);
-        LOGGER.info("HELLO");
-
-
-    }
-
-}
diff --git a/backend/src/main/java/cz/zcu/kiv/backend/controller/StubController.java b/backend/src/main/java/cz/zcu/kiv/backend/controller/StubController.java
deleted file mode 100644
index 5728a8c..0000000
--- a/backend/src/main/java/cz/zcu/kiv/backend/controller/StubController.java
+++ /dev/null
@@ -1,25 +0,0 @@
-package cz.zcu.kiv.backend.controller;
-
-import lombok.AllArgsConstructor;
-import org.slf4j.Logger;
-import org.slf4j.LoggerFactory;
-import org.springframework.stereotype.Controller;
-import org.springframework.web.bind.annotation.GetMapping;
-
-@Controller
-public class StubController {
-
-    public static final Logger LOGGER = LoggerFactory.getLogger(StubController.class);
-
-    @GetMapping("/stub")
-    public Response stub() {
-        LOGGER.debug("Stub");
-        return new Response(0, "Stub response");
-    }
-
-    @AllArgsConstructor
-    class Response {
-        int resCode;
-        String text;
-    }
-}
diff --git a/backend/src/main/java/cz/zcu/kiv/backendapi/BackendApiApplication.java b/backend/src/main/java/cz/zcu/kiv/backendapi/BackendApiApplication.java
new file mode 100644
index 0000000..3678128
--- /dev/null
+++ b/backend/src/main/java/cz/zcu/kiv/backendapi/BackendApiApplication.java
@@ -0,0 +1,18 @@
+package cz.zcu.kiv.backendapi;
+
+import java.util.logging.Logger;
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.SpringBootApplication;
+
+@SpringBootApplication
+public class BackendApiApplication {
+
+	// TODO replace with log4j?
+	public static final Logger LOGGER = Logger.getLogger(BackendApiApplication.class.getName());
+
+	public static void main(String[] args) {
+		LOGGER.info("Starting ...");
+		SpringApplication.run(BackendApiApplication.class, args);
+	}
+
+}
diff --git a/backend/src/main/java/cz/zcu/kiv/backendapi/StubController.java b/backend/src/main/java/cz/zcu/kiv/backendapi/StubController.java
new file mode 100644
index 0000000..867493a
--- /dev/null
+++ b/backend/src/main/java/cz/zcu/kiv/backendapi/StubController.java
@@ -0,0 +1,22 @@
+package cz.zcu.kiv.backendapi;
+
+import java.util.logging.Logger;
+import org.springframework.stereotype.Controller;
+import org.springframework.web.bind.annotation.GetMapping;
+import org.springframework.web.bind.annotation.RestController;
+
+@RestController()
+public class StubController {
+
+    public static final Logger LOGGER = Logger.getLogger(StubController.class.getName());
+
+
+    static {
+        LOGGER.info("StubController initialized!");
+    }
+
+    @GetMapping("/stub")
+    public StubDto getStubDto() {
+        return new StubDto("Hello API", true);
+    }
+}
diff --git a/backend/src/main/java/cz/zcu/kiv/backendapi/StubDto.java b/backend/src/main/java/cz/zcu/kiv/backendapi/StubDto.java
new file mode 100644
index 0000000..330a980
--- /dev/null
+++ b/backend/src/main/java/cz/zcu/kiv/backendapi/StubDto.java
@@ -0,0 +1,5 @@
+package cz.zcu.kiv.backendapi;
+
+
+import lombok.AllArgsConstructor;
+public record StubDto(String message, Boolean success) {}
diff --git a/map_frameworks/.gitignore b/map_frameworks/.gitignore
deleted file mode 100644
index 4d29575..0000000
--- a/map_frameworks/.gitignore
+++ /dev/null
@@ -1,23 +0,0 @@
-# See https://help.github.com/articles/ignoring-files/ for more about ignoring files.
-
-# dependencies
-/node_modules
-/.pnp
-.pnp.js
-
-# testing
-/coverage
-
-# production
-/build
-
-# misc
-.DS_Store
-.env.local
-.env.development.local
-.env.test.local
-.env.production.local
-
-npm-debug.log*
-yarn-debug.log*
-yarn-error.log*
diff --git a/map_frameworks/README.md b/map_frameworks/README.md
deleted file mode 100644
index b58e0af..0000000
--- a/map_frameworks/README.md
+++ /dev/null
@@ -1,46 +0,0 @@
-# Getting Started with Create React App
-
-This project was bootstrapped with [Create React App](https://github.com/facebook/create-react-app).
-
-## Available Scripts
-
-In the project directory, you can run:
-
-### `yarn start`
-
-Runs the app in the development mode.\
-Open [http://localhost:3000](http://localhost:3000) to view it in the browser.
-
-The page will reload if you make edits.\
-You will also see any lint errors in the console.
-
-### `yarn test`
-
-Launches the test runner in the interactive watch mode.\
-See the section about [running tests](https://facebook.github.io/create-react-app/docs/running-tests) for more information.
-
-### `yarn build`
-
-Builds the app for production to the `build` folder.\
-It correctly bundles React in production mode and optimizes the build for the best performance.
-
-The build is minified and the filenames include the hashes.\
-Your app is ready to be deployed!
-
-See the section about [deployment](https://facebook.github.io/create-react-app/docs/deployment) for more information.
-
-### `yarn eject`
-
-**Note: this is a one-way operation. Once you `eject`, you can’t go back!**
-
-If you aren’t satisfied with the build tool and configuration choices, you can `eject` at any time. This command will remove the single build dependency from your project.
-
-Instead, it will copy all the configuration files and the transitive dependencies (webpack, Babel, ESLint, etc) right into your project so you have full control over them. All of the commands except `eject` will still work, but they will point to the copied scripts so you can tweak them. At this point you’re on your own.
-
-You don’t have to ever use `eject`. The curated feature set is suitable for small and middle deployments, and you shouldn’t feel obligated to use this feature. However we understand that this tool wouldn’t be useful if you couldn’t customize it when you are ready for it.
-
-## Learn More
-
-You can learn more in the [Create React App documentation](https://facebook.github.io/create-react-app/docs/getting-started).
-
-To learn React, check out the [React documentation](https://reactjs.org/).
diff --git a/map_frameworks/package.json b/map_frameworks/package.json
deleted file mode 100644
index 1fd5ae9..0000000
--- a/map_frameworks/package.json
+++ /dev/null
@@ -1,54 +0,0 @@
-{
-  "name": "map_frameworks",
-  "version": "0.1.0",
-  "private": true,
-  "dependencies": {
-    "@testing-library/jest-dom": "^5.14.1",
-    "@testing-library/react": "^12.0.0",
-    "@testing-library/user-event": "^13.2.1",
-    "@types/": "urbica/react-map-gl",
-    "@types/dotenv": "^8.2.0",
-    "@types/jest": "^27.0.1",
-    "@types/leaflet": "^1.7.9",
-    "@types/mapbox-gl": "^2.6.2",
-    "@types/node": "^16.7.13",
-    "@types/react": "^17.0.20",
-    "@types/react-dom": "^17.0.9",
-    "@types/react-leaflet": "^2.8.2",
-    "@urbica/react-map-gl": "^1.14.4",
-    "leaflet": "^1.7.1",
-    "mapbox-gl": "^2.7.0",
-    "pigeon-maps": "^0.20.0",
-    "react": "^17.0.2",
-    "react-dom": "^17.0.2",
-    "react-leaflet": "^3.2.5",
-    "react-router-dom": "^6.2.2",
-    "react-scripts": "5.0.0",
-    "typescript": "^4.4.2",
-    "web-vitals": "^2.1.0"
-  },
-  "scripts": {
-    "start": "react-scripts start",
-    "build": "react-scripts build",
-    "test": "react-scripts test",
-    "eject": "react-scripts eject"
-  },
-  "eslintConfig": {
-    "extends": [
-      "react-app",
-      "react-app/jest"
-    ]
-  },
-  "browserslist": {
-    "production": [
-      ">0.2%",
-      "not dead",
-      "not op_mini all"
-    ],
-    "development": [
-      "last 1 chrome version",
-      "last 1 firefox version",
-      "last 1 safari version"
-    ]
-  }
-}
diff --git a/map_frameworks/public/favicon.ico b/map_frameworks/public/favicon.ico
deleted file mode 100644
index a11777c..0000000
Binary files a/map_frameworks/public/favicon.ico and /dev/null differ
diff --git a/map_frameworks/public/index.html b/map_frameworks/public/index.html
deleted file mode 100644
index 28f8431..0000000
--- a/map_frameworks/public/index.html
+++ /dev/null
@@ -1,47 +0,0 @@
-<!DOCTYPE html>
-<html lang="en">
-<head>
-    <meta charset="utf-8"/>
-    <link href="https://api.mapbox.com/mapbox-gl-js/v2.7.0/mapbox-gl.css" rel="stylesheet">
-    <link rel="icon" href="%PUBLIC_URL%/favicon.ico"/>
-    <meta name="viewport" content="width=device-width, initial-scale=1"/>
-    <meta name="theme-color" content="#000000"/>
-    <meta
-            name="description"
-            content="Web site created using create-react-app"
-    />
-    <link rel="apple-touch-icon" href="%PUBLIC_URL%/logo192.png"/>
-    <!--
-      manifest.json provides metadata used when your web app is installed on a
-      user's mobile device or desktop. See https://developers.google.com/web/fundamentals/web-app-manifest/
-    -->
-    <link rel="manifest" href="%PUBLIC_URL%/manifest.json"/>
-    <link rel="stylesheet" href="https://unpkg.com/leaflet@1.7.1/dist/leaflet.css"
-          integrity="sha512-xodZBNTC5n17Xt2atTPuE1HxjVMSvLVW9ocqUKLsCC5CXdbqCmblAshOMAS6/keqq/sMZMZ19scR4PsZChSR7A=="
-          crossorigin=""/>
-    <!--
-      Notice the use of %PUBLIC_URL% in the tags above.
-      It will be replaced with the URL of the `public` folder during the build.
-      Only files inside the `public` folder can be referenced from the HTML.
-
-      Unlike "/favicon.ico" or "favicon.ico", "%PUBLIC_URL%/favicon.ico" will
-      work correctly both with client-side routing and a non-root public URL.
-      Learn how to configure a non-root public URL by running `npm run build`.
-    -->
-    <title>React App</title>
-</head>
-<body>
-<noscript>You need to enable JavaScript to run this app.</noscript>
-<div id="root"></div>
-<!--
-  This HTML file is a template.
-  If you open it directly in the browser, you will see an empty page.
-
-  You can add webfonts, meta tags, or analytics to this file.
-  The build step will place the bundled scripts into the <body> tag.
-
-  To begin the development, run `npm start` or `yarn start`.
-  To create a production bundle, use `npm run build` or `yarn build`.
--->
-</body>
-</html>
diff --git a/map_frameworks/public/logo192.png b/map_frameworks/public/logo192.png
deleted file mode 100644
index fc44b0a..0000000
Binary files a/map_frameworks/public/logo192.png and /dev/null differ
diff --git a/map_frameworks/public/logo512.png b/map_frameworks/public/logo512.png
deleted file mode 100644
index a4e47a6..0000000
Binary files a/map_frameworks/public/logo512.png and /dev/null differ
diff --git a/map_frameworks/public/manifest.json b/map_frameworks/public/manifest.json
deleted file mode 100644
index 080d6c7..0000000
--- a/map_frameworks/public/manifest.json
+++ /dev/null
@@ -1,25 +0,0 @@
-{
-  "short_name": "React App",
-  "name": "Create React App Sample",
-  "icons": [
-    {
-      "src": "favicon.ico",
-      "sizes": "64x64 32x32 24x24 16x16",
-      "type": "image/x-icon"
-    },
-    {
-      "src": "logo192.png",
-      "type": "image/png",
-      "sizes": "192x192"
-    },
-    {
-      "src": "logo512.png",
-      "type": "image/png",
-      "sizes": "512x512"
-    }
-  ],
-  "start_url": ".",
-  "display": "standalone",
-  "theme_color": "#000000",
-  "background_color": "#ffffff"
-}
diff --git a/map_frameworks/public/robots.txt b/map_frameworks/public/robots.txt
deleted file mode 100644
index e9e57dc..0000000
--- a/map_frameworks/public/robots.txt
+++ /dev/null
@@ -1,3 +0,0 @@
-# https://www.robotstxt.org/robotstxt.html
-User-agent: *
-Disallow:
diff --git a/map_frameworks/src/App.css b/map_frameworks/src/App.css
deleted file mode 100644
index 74b5e05..0000000
--- a/map_frameworks/src/App.css
+++ /dev/null
@@ -1,38 +0,0 @@
-.App {
-  text-align: center;
-}
-
-.App-logo {
-  height: 40vmin;
-  pointer-events: none;
-}
-
-@media (prefers-reduced-motion: no-preference) {
-  .App-logo {
-    animation: App-logo-spin infinite 20s linear;
-  }
-}
-
-.App-header {
-  background-color: #282c34;
-  min-height: 100vh;
-  display: flex;
-  flex-direction: column;
-  align-items: center;
-  justify-content: center;
-  font-size: calc(10px + 2vmin);
-  color: white;
-}
-
-.App-link {
-  color: #61dafb;
-}
-
-@keyframes App-logo-spin {
-  from {
-    transform: rotate(0deg);
-  }
-  to {
-    transform: rotate(360deg);
-  }
-}
diff --git a/map_frameworks/src/App.tsx b/map_frameworks/src/App.tsx
deleted file mode 100644
index 625e521..0000000
--- a/map_frameworks/src/App.tsx
+++ /dev/null
@@ -1,15 +0,0 @@
-import React from 'react'
-import './App.css'
-import MapBoxExample from './component/MapBoxExample'
-import PigeonMapsExample from './component/PigeonMapsExample'
-import LeafletExample from './component/LeafletExample'
-
-const App = () => (
-    <div className="App">
-        <MapBoxExample/>
-        <PigeonMapsExample/>
-        <LeafletExample />
-    </div>
-)
-
-export default App
diff --git a/map_frameworks/src/component/LeafletExample.tsx b/map_frameworks/src/component/LeafletExample.tsx
deleted file mode 100644
index 2bbf1cc..0000000
--- a/map_frameworks/src/component/LeafletExample.tsx
+++ /dev/null
@@ -1,25 +0,0 @@
-// Wrapper around leaflet -> https://react-leaflet.js.org/docs/start-setup/
-import { MapContainer, Marker, Popup, SVGOverlay, TileLayer } from 'react-leaflet'
-import MapBoxExample from './MapBoxExample'
-
-const LeafletExample = () => {
-
-    return (
-        <>
-            <h1>Leaflet Example</h1>
-            <MapContainer style={ { height: 450 } } center={ [51.505, -0.09] } zoom={ 13 }>
-                <TileLayer
-                    attribution='&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'
-                    url="https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png"
-                />
-                <Marker position={ [51.505, -0.09] }>
-                    <Popup>
-                        <MapBoxExample />
-                    </Popup>
-                </Marker>
-            </MapContainer>
-        </>
-    )
-}
-
-export default LeafletExample
\ No newline at end of file
diff --git a/map_frameworks/src/component/MapBoxExample.tsx b/map_frameworks/src/component/MapBoxExample.tsx
deleted file mode 100644
index 53f43d6..0000000
--- a/map_frameworks/src/component/MapBoxExample.tsx
+++ /dev/null
@@ -1,63 +0,0 @@
-import React, { useEffect, useRef, useState } from 'react'
-import mapboxgl, { LngLatLike, Popup } from 'mapbox-gl'
-
-
-const coords = {
-    lng: 7.3700,
-    lat: 60.0400
-}
-
-// Adapted from
-// https://docs.mapbox.com/help/tutorials/use-mapbox-gl-js-with-react/
-
-// Potential wrapper could be: https://github.com/alex3165/react-mapbox-gl
-// https://docs.mapbox.com/mapbox-gl-js/example/geojson-line/
-
-// But has only 50k uses PER MONTH lol
-const MapBoxExample = () => {
-
-    const [lng, setLng] = useState(coords.lng)
-    const [lat, setLat] = useState(coords.lat)
-    const [zoom, setZoom] = useState(1)
-
-    // TODO type
-    const map = useRef<any>(null)
-    const mapContainer = useRef<any>(null)
-
-    // Function to add markers to the map
-    const addMarkers = () => {
-        for (let i = 1; i <= 10; i += 1) { //
-            new mapboxgl.Marker()
-                .setLngLat([i * .5 + coords.lng, i * .5 + coords.lat])
-                .setPopup(new Popup().setHTML(`<h3>HELLO POPUP ${ i } ☀️🍕😂😅</h3>`))
-                .addTo(map.current as mapboxgl.Map)
-        }
-    }
-
-    useEffect(() => {
-        if (map.current) {
-            return
-        }
-
-        map.current = new mapboxgl.Map({
-            container: mapContainer.current,
-            center: [lng, lat],
-            accessToken: process.env.REACT_APP_MAPS_API_KEY,
-            style: 'mapbox://styles/mapbox/streets-v11',
-            zoom: zoom
-        })
-
-        map.current.addControl(new mapboxgl.NavigationControl())
-
-        addMarkers()
-    })
-
-    return (
-        <>
-            <h1>MapBox Example</h1>
-            <div ref={ mapContainer } style={ { height: '400px' } }/>
-        </>
-    )
-}
-
-export default MapBoxExample
\ No newline at end of file
diff --git a/map_frameworks/src/component/PigeonMapsExample.tsx b/map_frameworks/src/component/PigeonMapsExample.tsx
deleted file mode 100644
index fcf365b..0000000
--- a/map_frameworks/src/component/PigeonMapsExample.tsx
+++ /dev/null
@@ -1,16 +0,0 @@
-import { Map, Marker } from 'pigeon-maps'
-import { useState } from 'react'
-
-// This would be also a great library but did not find any official way to draw path
-const PigeonMapsExample = () => {
-    return (
-        <>
-            <h1>PigeonMaps Example</h1>
-            <Map height={ 400 } defaultCenter={ [50.879, 4.6997] } defaultZoom={ 11 }>
-                <Marker width={ 50 } anchor={ [50.879, 4.6997] }/>
-            </Map>
-        </>
-    )
-}
-
-export default PigeonMapsExample
\ No newline at end of file
diff --git a/map_frameworks/src/index.css b/map_frameworks/src/index.css
deleted file mode 100644
index ec2585e..0000000
--- a/map_frameworks/src/index.css
+++ /dev/null
@@ -1,13 +0,0 @@
-body {
-  margin: 0;
-  font-family: -apple-system, BlinkMacSystemFont, 'Segoe UI', 'Roboto', 'Oxygen',
-    'Ubuntu', 'Cantarell', 'Fira Sans', 'Droid Sans', 'Helvetica Neue',
-    sans-serif;
-  -webkit-font-smoothing: antialiased;
-  -moz-osx-font-smoothing: grayscale;
-}
-
-code {
-  font-family: source-code-pro, Menlo, Monaco, Consolas, 'Courier New',
-    monospace;
-}
diff --git a/map_frameworks/src/index.tsx b/map_frameworks/src/index.tsx
deleted file mode 100644
index 0c11372..0000000
--- a/map_frameworks/src/index.tsx
+++ /dev/null
@@ -1,12 +0,0 @@
-import React from 'react'
-import ReactDOM from 'react-dom'
-import './index.css'
-import App from './App'
-
-ReactDOM.render(
-    <React.StrictMode>
-        <App/>
-    </React.StrictMode>,
-    document.getElementById('root')
-)
-
diff --git a/map_frameworks/src/react-app-env.d.ts b/map_frameworks/src/react-app-env.d.ts
deleted file mode 100644
index 6431bc5..0000000
--- a/map_frameworks/src/react-app-env.d.ts
+++ /dev/null
@@ -1 +0,0 @@
-/// <reference types="react-scripts" />
diff --git a/map_frameworks/src/setupTests.ts b/map_frameworks/src/setupTests.ts
deleted file mode 100644
index 8f2609b..0000000
--- a/map_frameworks/src/setupTests.ts
+++ /dev/null
@@ -1,5 +0,0 @@
-// jest-dom adds custom jest matchers for asserting on DOM nodes.
-// allows you to do things like:
-// expect(element).toHaveTextContent(/react/i)
-// learn more: https://github.com/testing-library/jest-dom
-import '@testing-library/jest-dom';
diff --git a/map_frameworks/tsconfig.json b/map_frameworks/tsconfig.json
deleted file mode 100644
index a273b0c..0000000
--- a/map_frameworks/tsconfig.json
+++ /dev/null
@@ -1,26 +0,0 @@
-{
-  "compilerOptions": {
-    "target": "es5",
-    "lib": [
-      "dom",
-      "dom.iterable",
-      "esnext"
-    ],
-    "allowJs": true,
-    "skipLibCheck": true,
-    "esModuleInterop": true,
-    "allowSyntheticDefaultImports": true,
-    "strict": true,
-    "forceConsistentCasingInFileNames": true,
-    "noFallthroughCasesInSwitch": true,
-    "module": "esnext",
-    "moduleResolution": "node",
-    "resolveJsonModule": true,
-    "isolatedModules": true,
-    "noEmit": true,
-    "jsx": "react-jsx"
-  },
-  "include": [
-    "src"
-  ]
-}