commit eb408fe9b77a30a83e4820355e4658bf4d834d70
Author: Vaclav Honzik <vaclavhonzik98@gmail.com>
Date:   Wed Mar 2 22:45:05 2022 +0100

    MapBoxExample test with React #9101

diff --git a/map_frameworks/.gitignore b/map_frameworks/.gitignore
new file mode 100644
index 0000000..4d29575
--- /dev/null
+++ b/map_frameworks/.gitignore
@@ -0,0 +1,23 @@
+# See https://help.github.com/articles/ignoring-files/ for more about ignoring files.
+
+# dependencies
+/node_modules
+/.pnp
+.pnp.js
+
+# testing
+/coverage
+
+# production
+/build
+
+# misc
+.DS_Store
+.env.local
+.env.development.local
+.env.test.local
+.env.production.local
+
+npm-debug.log*
+yarn-debug.log*
+yarn-error.log*
diff --git a/map_frameworks/README.md b/map_frameworks/README.md
new file mode 100644
index 0000000..b58e0af
--- /dev/null
+++ b/map_frameworks/README.md
@@ -0,0 +1,46 @@
+# Getting Started with Create React App
+
+This project was bootstrapped with [Create React App](https://github.com/facebook/create-react-app).
+
+## Available Scripts
+
+In the project directory, you can run:
+
+### `yarn start`
+
+Runs the app in the development mode.\
+Open [http://localhost:3000](http://localhost:3000) to view it in the browser.
+
+The page will reload if you make edits.\
+You will also see any lint errors in the console.
+
+### `yarn test`
+
+Launches the test runner in the interactive watch mode.\
+See the section about [running tests](https://facebook.github.io/create-react-app/docs/running-tests) for more information.
+
+### `yarn build`
+
+Builds the app for production to the `build` folder.\
+It correctly bundles React in production mode and optimizes the build for the best performance.
+
+The build is minified and the filenames include the hashes.\
+Your app is ready to be deployed!
+
+See the section about [deployment](https://facebook.github.io/create-react-app/docs/deployment) for more information.
+
+### `yarn eject`
+
+**Note: this is a one-way operation. Once you `eject`, you can’t go back!**
+
+If you aren’t satisfied with the build tool and configuration choices, you can `eject` at any time. This command will remove the single build dependency from your project.
+
+Instead, it will copy all the configuration files and the transitive dependencies (webpack, Babel, ESLint, etc) right into your project so you have full control over them. All of the commands except `eject` will still work, but they will point to the copied scripts so you can tweak them. At this point you’re on your own.
+
+You don’t have to ever use `eject`. The curated feature set is suitable for small and middle deployments, and you shouldn’t feel obligated to use this feature. However we understand that this tool wouldn’t be useful if you couldn’t customize it when you are ready for it.
+
+## Learn More
+
+You can learn more in the [Create React App documentation](https://facebook.github.io/create-react-app/docs/getting-started).
+
+To learn React, check out the [React documentation](https://reactjs.org/).
diff --git a/map_frameworks/package.json b/map_frameworks/package.json
new file mode 100644
index 0000000..55aa3fe
--- /dev/null
+++ b/map_frameworks/package.json
@@ -0,0 +1,46 @@
+{
+  "name": "map_frameworks",
+  "version": "0.1.0",
+  "private": true,
+  "dependencies": {
+    "@testing-library/jest-dom": "^5.14.1",
+    "@testing-library/react": "^12.0.0",
+    "@testing-library/user-event": "^13.2.1",
+    "@types/dotenv": "^8.2.0",
+    "@types/jest": "^27.0.1",
+    "@types/mapbox-gl": "^2.6.2",
+    "@types/node": "^16.7.13",
+    "@types/react": "^17.0.20",
+    "@types/react-dom": "^17.0.9",
+    "mapbox-gl": "^2.7.0",
+    "react": "^17.0.2",
+    "react-dom": "^17.0.2",
+    "react-scripts": "5.0.0",
+    "typescript": "^4.4.2",
+    "web-vitals": "^2.1.0"
+  },
+  "scripts": {
+    "start": "react-scripts start",
+    "build": "react-scripts build",
+    "test": "react-scripts test",
+    "eject": "react-scripts eject"
+  },
+  "eslintConfig": {
+    "extends": [
+      "react-app",
+      "react-app/jest"
+    ]
+  },
+  "browserslist": {
+    "production": [
+      ">0.2%",
+      "not dead",
+      "not op_mini all"
+    ],
+    "development": [
+      "last 1 chrome version",
+      "last 1 firefox version",
+      "last 1 safari version"
+    ]
+  }
+}
diff --git a/map_frameworks/public/favicon.ico b/map_frameworks/public/favicon.ico
new file mode 100644
index 0000000..a11777c
Binary files /dev/null and b/map_frameworks/public/favicon.ico differ
diff --git a/map_frameworks/public/index.html b/map_frameworks/public/index.html
new file mode 100644
index 0000000..788ff16
--- /dev/null
+++ b/map_frameworks/public/index.html
@@ -0,0 +1,44 @@
+<!DOCTYPE html>
+<html lang="en">
+<head>
+    <meta charset="utf-8"/>
+    <link href="https://api.mapbox.com/mapbox-gl-js/v2.7.0/mapbox-gl.css" rel="stylesheet">
+    <link rel="icon" href="%PUBLIC_URL%/favicon.ico"/>
+    <meta name="viewport" content="width=device-width, initial-scale=1"/>
+    <meta name="theme-color" content="#000000"/>
+    <meta
+            name="description"
+            content="Web site created using create-react-app"
+    />
+    <link rel="apple-touch-icon" href="%PUBLIC_URL%/logo192.png"/>
+    <!--
+      manifest.json provides metadata used when your web app is installed on a
+      user's mobile device or desktop. See https://developers.google.com/web/fundamentals/web-app-manifest/
+    -->
+    <link rel="manifest" href="%PUBLIC_URL%/manifest.json"/>
+    <!--
+      Notice the use of %PUBLIC_URL% in the tags above.
+      It will be replaced with the URL of the `public` folder during the build.
+      Only files inside the `public` folder can be referenced from the HTML.
+
+      Unlike "/favicon.ico" or "favicon.ico", "%PUBLIC_URL%/favicon.ico" will
+      work correctly both with client-side routing and a non-root public URL.
+      Learn how to configure a non-root public URL by running `npm run build`.
+    -->
+    <title>React App</title>
+</head>
+<body>
+<noscript>You need to enable JavaScript to run this app.</noscript>
+<div id="root"></div>
+<!--
+  This HTML file is a template.
+  If you open it directly in the browser, you will see an empty page.
+
+  You can add webfonts, meta tags, or analytics to this file.
+  The build step will place the bundled scripts into the <body> tag.
+
+  To begin the development, run `npm start` or `yarn start`.
+  To create a production bundle, use `npm run build` or `yarn build`.
+-->
+</body>
+</html>
diff --git a/map_frameworks/public/logo192.png b/map_frameworks/public/logo192.png
new file mode 100644
index 0000000..fc44b0a
Binary files /dev/null and b/map_frameworks/public/logo192.png differ
diff --git a/map_frameworks/public/logo512.png b/map_frameworks/public/logo512.png
new file mode 100644
index 0000000..a4e47a6
Binary files /dev/null and b/map_frameworks/public/logo512.png differ
diff --git a/map_frameworks/public/manifest.json b/map_frameworks/public/manifest.json
new file mode 100644
index 0000000..080d6c7
--- /dev/null
+++ b/map_frameworks/public/manifest.json
@@ -0,0 +1,25 @@
+{
+  "short_name": "React App",
+  "name": "Create React App Sample",
+  "icons": [
+    {
+      "src": "favicon.ico",
+      "sizes": "64x64 32x32 24x24 16x16",
+      "type": "image/x-icon"
+    },
+    {
+      "src": "logo192.png",
+      "type": "image/png",
+      "sizes": "192x192"
+    },
+    {
+      "src": "logo512.png",
+      "type": "image/png",
+      "sizes": "512x512"
+    }
+  ],
+  "start_url": ".",
+  "display": "standalone",
+  "theme_color": "#000000",
+  "background_color": "#ffffff"
+}
diff --git a/map_frameworks/public/robots.txt b/map_frameworks/public/robots.txt
new file mode 100644
index 0000000..e9e57dc
--- /dev/null
+++ b/map_frameworks/public/robots.txt
@@ -0,0 +1,3 @@
+# https://www.robotstxt.org/robotstxt.html
+User-agent: *
+Disallow:
diff --git a/map_frameworks/src/App.css b/map_frameworks/src/App.css
new file mode 100644
index 0000000..74b5e05
--- /dev/null
+++ b/map_frameworks/src/App.css
@@ -0,0 +1,38 @@
+.App {
+  text-align: center;
+}
+
+.App-logo {
+  height: 40vmin;
+  pointer-events: none;
+}
+
+@media (prefers-reduced-motion: no-preference) {
+  .App-logo {
+    animation: App-logo-spin infinite 20s linear;
+  }
+}
+
+.App-header {
+  background-color: #282c34;
+  min-height: 100vh;
+  display: flex;
+  flex-direction: column;
+  align-items: center;
+  justify-content: center;
+  font-size: calc(10px + 2vmin);
+  color: white;
+}
+
+.App-link {
+  color: #61dafb;
+}
+
+@keyframes App-logo-spin {
+  from {
+    transform: rotate(0deg);
+  }
+  to {
+    transform: rotate(360deg);
+  }
+}
diff --git a/map_frameworks/src/App.tsx b/map_frameworks/src/App.tsx
new file mode 100644
index 0000000..bdbdc05
--- /dev/null
+++ b/map_frameworks/src/App.tsx
@@ -0,0 +1,13 @@
+import React from 'react'
+import './App.css'
+import MapBoxExample from './component/MapBoxExample'
+
+function App() {
+    return (
+        <div className="App">
+            <MapBoxExample/>
+        </div>
+    )
+}
+
+export default App
diff --git a/map_frameworks/src/component/MapBoxExample.tsx b/map_frameworks/src/component/MapBoxExample.tsx
new file mode 100644
index 0000000..16bd8ce
--- /dev/null
+++ b/map_frameworks/src/component/MapBoxExample.tsx
@@ -0,0 +1,61 @@
+import React, { useEffect, useRef, useState } from 'react'
+import mapboxgl, { LngLatLike, Popup } from 'mapbox-gl'
+
+
+const coords = {
+    lng: 7.3700,
+    lat: 60.0400
+}
+
+// Adapted from
+// https://docs.mapbox.com/help/tutorials/use-mapbox-gl-js-with-react/
+const MapBoxExample = () => {
+
+    const [lng, setLng] = useState(coords.lng)
+    const [lat, setLat] = useState(coords.lat)
+    const [zoom, setZoom] = useState(1)
+
+    // TODO type
+    const map = useRef<any>(null)
+    const mapContainer = useRef<any>(null)
+
+    // Function to add markers to the map
+    const addMarkers = () => {
+        for (let i = 1; i <= 10; i += 1) { //
+            new mapboxgl.Marker()
+                .setLngLat([i * .5 + coords.lng, i * .5 + coords.lat])
+                .setPopup(new Popup()
+                    .setHTML(`<h3>HELLO POPUP ${ i } ☀️🍕😂😅</h3>`))
+                .addTo(map.current as mapboxgl.Map)
+        }
+    }
+
+    useEffect(() => {
+        if (map.current) {
+            return
+        }
+
+        map.current = new mapboxgl.Map({
+            container: mapContainer.current,
+            center: [lng, lat],
+            accessToken: process.env.REACT_APP_MAPS_API_KEY,
+            style: 'mapbox://styles/mapbox/streets-v11',
+            zoom: zoom
+        })
+
+        map.current.addControl(new mapboxgl.NavigationControl())
+
+        addMarkers()
+    })
+
+    console.log('Whatup')
+
+    return (
+        <div>
+            <h1>Hello Map</h1>
+            <div ref={ mapContainer } style={ { height: '700px' } }/>
+        </div>
+    )
+}
+
+export default MapBoxExample
\ No newline at end of file
diff --git a/map_frameworks/src/index.css b/map_frameworks/src/index.css
new file mode 100644
index 0000000..ec2585e
--- /dev/null
+++ b/map_frameworks/src/index.css
@@ -0,0 +1,13 @@
+body {
+  margin: 0;
+  font-family: -apple-system, BlinkMacSystemFont, 'Segoe UI', 'Roboto', 'Oxygen',
+    'Ubuntu', 'Cantarell', 'Fira Sans', 'Droid Sans', 'Helvetica Neue',
+    sans-serif;
+  -webkit-font-smoothing: antialiased;
+  -moz-osx-font-smoothing: grayscale;
+}
+
+code {
+  font-family: source-code-pro, Menlo, Monaco, Consolas, 'Courier New',
+    monospace;
+}
diff --git a/map_frameworks/src/index.tsx b/map_frameworks/src/index.tsx
new file mode 100644
index 0000000..0c11372
--- /dev/null
+++ b/map_frameworks/src/index.tsx
@@ -0,0 +1,12 @@
+import React from 'react'
+import ReactDOM from 'react-dom'
+import './index.css'
+import App from './App'
+
+ReactDOM.render(
+    <React.StrictMode>
+        <App/>
+    </React.StrictMode>,
+    document.getElementById('root')
+)
+
diff --git a/map_frameworks/src/react-app-env.d.ts b/map_frameworks/src/react-app-env.d.ts
new file mode 100644
index 0000000..6431bc5
--- /dev/null
+++ b/map_frameworks/src/react-app-env.d.ts
@@ -0,0 +1 @@
+/// <reference types="react-scripts" />
diff --git a/map_frameworks/src/setupTests.ts b/map_frameworks/src/setupTests.ts
new file mode 100644
index 0000000..8f2609b
--- /dev/null
+++ b/map_frameworks/src/setupTests.ts
@@ -0,0 +1,5 @@
+// jest-dom adds custom jest matchers for asserting on DOM nodes.
+// allows you to do things like:
+// expect(element).toHaveTextContent(/react/i)
+// learn more: https://github.com/testing-library/jest-dom
+import '@testing-library/jest-dom';
diff --git a/map_frameworks/tsconfig.json b/map_frameworks/tsconfig.json
new file mode 100644
index 0000000..a273b0c
--- /dev/null
+++ b/map_frameworks/tsconfig.json
@@ -0,0 +1,26 @@
+{
+  "compilerOptions": {
+    "target": "es5",
+    "lib": [
+      "dom",
+      "dom.iterable",
+      "esnext"
+    ],
+    "allowJs": true,
+    "skipLibCheck": true,
+    "esModuleInterop": true,
+    "allowSyntheticDefaultImports": true,
+    "strict": true,
+    "forceConsistentCasingInFileNames": true,
+    "noFallthroughCasesInSwitch": true,
+    "module": "esnext",
+    "moduleResolution": "node",
+    "resolveJsonModule": true,
+    "isolatedModules": true,
+    "noEmit": true,
+    "jsx": "react-jsx"
+  },
+  "include": [
+    "src"
+  ]
+}